package _VisualDVM.Passes.All;
import Common.Passes.Pass;
import Common.Utils.Utils_;
import _VisualDVM.Global;
import _VisualDVM.GlobalData.Tasks.RunTask.RunTask;

import java.util.Vector;
public class DeleteSelectedRunTasks extends Pass<Vector<RunTask>> {
    @Override
    public String getIconPath() {
        return "/icons/Delete.png";
    }
    @Override
    public String getButtonText() {
        return "";
    }
    @Override
    protected boolean canStart(Object... args) throws Exception {
        target = new Vector<>();
        (Global.mainModule.getDb()).runTasks.Data.values().stream().filter(task -> task.isVisible() && task.isSelected() && task.isPassive()).forEach(task -> target.add(task));
        if (target.isEmpty()) {
            Log.Writeln_("Не отмечено ни одной задачи для удаления.");
            return false;
        } else return true;
    }
    @Override
    protected void showPreparation() throws Exception {
        Global.mainModule.getDb().runTasks.ClearUI();
    }
    @Override
    protected void body() throws Exception {
        for (RunTask task : target) {
            Global.mainModule.getDb().Delete(task);
            Utils_.forceDeleteWithCheck(task.getLocalWorkspace());
        }
    }
    @Override
    protected void showFinish() throws Exception {
        Global.mainModule.getDb().runTasks.ShowUI();
    }
}
